<template>
    <div class="fullscreen"></div>
    <v-row justify="center">
        <v-dialog 
        v-model="dialog" 
        width="600"
        dark 
        absolute
                >

            <v-card v-if="login" >
                    <img src="assets/img/logo.png" alt="logo" class="mx-auto d-block logo" style="width: 250px;  margin-top: 20px; margin-bottom: 20px;">

                    <v-card-text>

                        <v-form @submit.prevent="submitLogin()">
                        <v-container class="flex ">
                            <v-row>
                                <v-col >
                                    <v-text-field
                                    label="Email"
                                    v-model="credentials.email"
                                    :rules="[rules.required, rules.email]"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    <v-text-field
                                    type="password"
                                    label="Password"
                                    v-model="credentials.password"
                                    :rules="[rules.required]"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row v-if="message != ''">
                                <v-col>

                                    {{message}}
                                </v-col>
                            </v-row>
                           
                        </v-container>
                       

                       
                        <v-container class="flex text-center">
                        
                            <v-btn color="primary" type="submit">Login</v-btn>
                            
                        </v-container>
                        <v-container>

                            <v-btn color="hint" variant="text" disabled>No account?</v-btn><v-btn color="info" variant="text" @click="login = false">Sign Up</v-btn>
                        </v-container>
                        </v-form>
                </v-card-text>

            </v-card>
            <v-card v-else> 
                <img src="assets/img/logo.png" alt="logo" class="mx-auto d-block logo" style="width: 250px;  margin-top: 20px; margin-bottom: 20px;">

                    <v-card-text>
                        
                    <v-form  @submit.prevent="submitSignUpForm" >
                        <v-container class="flex ">
                            <v-row>
                                <v-col cols="6">
                                    <v-text-field
                                    label="First"
                                    name="first"
                                    v-model="signUpInfo.first"
                                    :rules="[rules.required]"
                                    ></v-text-field>
                                </v-col>
                                <v-col cols="6">
                                    <v-text-field
                                    label="Last"
                                    name="last"
                                    v-model="signUpInfo.last"
                                    :rules="[rules.required]"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    <v-text-field
                                    label="Email"
                                    name="email"
                                    v-model="signUpInfo.email"
                                    :rules="[rules.required, rules.email]"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    
                                    <v-text-field
                                        label="Password"
                                        name="password"
                                        v-model="signUpInfo.password"
                                        type="password"
                                        :rules="[rules.required, rules.min]"
                                        ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>

                                    <v-text-field
                                        label="Confirm Password"
                                        v-model="signUpInfo.password2"
                                        type="password"
                                        :rules="[rules.same]"
                                        ></v-text-field>
                                </v-col>
                            </v-row>
                        </v-container>
                       

                       
                        <v-container class="flex text-center">
                        
                            <v-btn color="primary" type="submit">Sign-Up</v-btn>
                            
                        </v-container>
                        <v-container>

                            <v-btn color="hint" variant="text" disabled>Already Have an Account?</v-btn><v-btn color="info" variant="text" @click="login = true">LogIn</v-btn>
                        </v-container>
                    </v-form>
                </v-card-text>

            </v-card>
    </v-dialog>
</v-row></template>
<style>

.fullscreen {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba(0, 0, 0, 1); /* add a semi-transparent background color */
  }

</style>
<script >
import { reactive, ref } from 'vue'
import { useAuthStore } from '@/store/auth';
import { useUserStore } from '@/store/users';
import router from '@/router';
import { onMounted } from 'vue';

export default {
    props: {},
    setup(props ) {

        const authStore = useAuthStore();
        const userStore = useUserStore();

        const login = ref(true);
        const message = ref('')

        const dialog = reactive({
            visible: true
        });
        const credentials = reactive({
            email: '',
            password: ''
        });
        const signUpInfo = reactive({
            first: '',
            last: '',
            email: '',
            password: '',
            password2: ''
        });

        const rules = reactive({
            required: (value) => !!value || 'Required.',
            min: (v) => v.length >= 8 || 'Min 8 characters',
            email: (v) => /.+@.+\..+/.test(v) || 'E-mail must be valid',
            same: (v) => v === signUpInfo.password || 'Passwords must match'
        });

        async function submitSignUpForm() {

            
            const resp  = await userStore.signUpUser(signUpInfo);
            
            switch(resp.status){
                case 200:
                case 201:
                    login.value = true;
                    credentials.password = signUpInfo.password;
                    credentials.email = signUpInfo.email;
                    message.value = '';
                    signUpInfo.email = '';
                    signUpInfo.password = '';
                    signUpInfo.password2 = '';
                    signUpInfo.first = '';
                    signUpInfo.last = '';
                    submitLogin();
                   break;
               default:
                   console.log("Something went wrong");
                   break;
           }

        }

        async function submitLogin() {

            const resp = await authStore.login(credentials) ;

            switch(resp.status){
                case 200:
                case 201:
                   message.value = '';
                   credentials.email = '';
                   credentials.password = '';
                  
                   router.push('/dashboard');
                   break;
                case 403:
                    message.value = "User exists but is still pending approval. See your administrator for more information."
                    break;
               default:
                   message.value = "Login Failed. Please check your credentials and try again."
                   break;
           }
        }

        onMounted(() => {
            authStore.fetchConfig();
        })


        return {
            dialog,
            credentials,
            login,
            signUpInfo,
            rules,
            submitLogin,
            submitSignUpForm,
            message
        };
    },
    components: { 
       
     }
}

</script>